# pd3: a way to break free from itunes and not lift your hands from
# the keyboard, except to curse lost commands which forever wander
# through the Great Tail-Pipe Unknown.
# Copyright (C) 2009 Enrique Martinez (enrique at enmimano.org)

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

find_artist() {
	COMPREPLY=( $(compgen -W "$(cat "$conf_path"/where | while read dir; do find "$dir" -type d -maxdepth 1 -mindepth 1 -iname "${cur}*" | gsed -e "s,$dir/,," -e "s, ,.,g" ; done)" -- "$cur") )
}

find_album() { 
	COMPREPLY=( $(compgen -W "$(cat "$conf_path"/where | while read dir; do find "$dir" -type d -mindepth 2 -maxdepth 2 -iname "${cur}*" | gsed -e "s,.*/,," -e "s, ,.,g"; done)" -- "$cur") )
}

find_album_by_artist() { 
	COMPREPLY=( $(compgen -W "$(cat "$conf_path"/where | while read dir; do if [ -d "$dir/$artist" ]; then find "$dir" -type d -mindepth 2 -maxdepth 2 -iname "${cur}"; fi | gsed -e "s,.*/,," -e "s, ,.,g"; done)" -- "$cur") )
}

find_song() {
	COMPREPLY=( $(compgen -W "$(cat "$conf_path"/where | while read dir; do find "$dir" -type f -mindepth 3 -iname "${cur}*" | gsed -e "s,.*/,," -e "s,\.[^\.]*$,," -e "s, ,.,g" ; done)" -- "$cur") )
}

find_song_by_album() {
	COMPREPLY=( $(compgen -W "$(cat "$conf_path"/where | while read dir; do find "$dir" -path "*/$album/*" -type f -mindepth 3 -iname "${cur}*" | gsed -e "s,.*/,," -e "s, ,.,g" ; done)" -- "$cur") )
}

find_song_by_album_artist() {
	COMPREPLY=( $(compgen -W "$(cat "$conf_path"/where | while read dir; do find "$dir" -path "*/$artist/$album/*" -type f -mindepth 3 -iname "${cur}*" | gsed -e "s,.*/,," -e "s, ,.,g" ; done)" -- "$cur") )
}

_lucia() 
{
  local cmd cur prev opts
  COMPREPLY=()
	cmd=${COMP_WORDS[1]}
	cur=${COMP_WORDS[COMP_CWORD]}
  opts="disco artista la busca bucle sig ahora pausa lista ant apaga_y_vamonos olvidame cada_vez otra_vez dime baraja salta cancion para"

	if [ $COMP_CWORD -eq 1 ]; then
		COMPREPLY=( $(compgen -W "$opts" -- "$cur") )
		return 0
	fi
	case "$cmd" in
	artista|disco|cancion)
		case "${COMP_WORDS[1]}$COMP_CWORD" in
		*2) 
			COMPREPLY=( $(compgen -W "mete saca" -- "$cur") )
			return 0
			;;
		artista3)
			find_artist
			return 0
			;;
		disco3)
			find_album
			return 0
			;;
		cancion3)
			find_song
			return 0
			;;
		esac
		;;
	reset) return 0;;
	busca)
		case "${COMP_WORDS[2]}$COMP_CWORD" in
		*2)
			COMPREPLY=( $(compgen -W "cancion disco disco_cancion artista artista_disco artista_disco_cancion disco_cancion" -- "$cur") ) 
			return 0
			;;
		artista3)
			find_artist
			return 0
			;;
		disco3)
			find_album
			return 0
			;;
		cancion3)
			find_song
			return 0
			;;
		disco_cancion3)
			find_album
			return 0
			;;
		disco_cancion4)
			album=`echo ${COMP_WORDS[3]} | tr '.' '?'`
			find_song_by_album
			return 0
			;;
		artista_disco3)
			find_artist
			return 0
			;;
		artista_disco4)
			artist=`echo ${COMP_WORDS[3]} | tr '.' '?'`
			find_album_by_artist
			return 0
			;;
		artista_disco_cancion3)
			find_artist
			return 0
			;;
		artista_disco_cancion4)
			artist=`echo ${COMP_WORDS[3]} | tr '.' '?'`
			find_album_by_artist
			return 0
			;;
		artista_disco_cancion5)
			artist=`echo ${COMP_WORDS[3]} | tr '.' '?'`
			album=`echo ${COMP_WORDS[4]} | tr '.' '?'`
			find_song_by_album_artist
			return 0
			;;
		esac
		;;
	baraja|cada_vez)
		COMPREPLY=( $(compgen -W "si no" -- "$cur") )
		return 0
		;;
	dime)
		COMPREPLY=( $(compgen -W "si no ahora" -- "$cur") )
		return 0
		;;
	otra_vez) return 0;;
	bucle)
		COMPREPLY=( $(compgen -W "todas no esta" -- "$cur") )
		return 0
		;;
	ant|sig|la|salta|pausa|para|ahora|lista|apaga_y_vamonos)
		return 0
		;;
  esac
}
complete -F _lucia lucia
